require 'hashie'
require 'faraday'
require 'json'

require_relative "brainspace/version"
require_relative "brainspace/article"
require_relative "brainspace/collection"

module Brainspace

  CONFIG = Hashie::Mash.new({
    host: "https://api.brainspace.com",
    user: nil,
    password: nil
  })

  def self.config
    CONFIG
  end

  def self.apikey
    JSON.parse(Faraday.get("#{config.host}/authenticate", {pass: config.password, user: config.user}).body)['data']
  rescue
    nil
  end
end
