require 'hashie'

module Brainspace
  class Article
    def initialize(attributes)
      @mash = attributes
    end

    def method_missing(method_sym, *arguments, &block)
      @mash.send(method_sym, *arguments)
    end

    def self.discover(query)
      response = Faraday.get("#{Brainspace.config.host}/discovery/concept", apikey: Brainspace.apikey, query: query)
      result = JSON.parse(response.body)
      articles = Hashie::Mash.new(result).data.map {|d| d.articles.first.merge(source: d.id) }
      articles.map { |article| Brainspace::Article.new(article) }
    rescue
      []
    end

    def to_json(opts)
      @mash.to_json(opts)
    end

    def as_json(opts)
      @mash.as_json(opts)
    end
  end
end
